/***************************************************************************
   Copyright (C) 2007 by Matthias Lechner <matthias@lmme.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the
   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KMOBILETOOLS_IFACESWIZARDPROVIDER_H
#define KMOBILETOOLS_IFACESWIZARDPROVIDER_H

#include <libkmobiletools/kmobiletools_export.h>

#include <QtGui/QWizardPage>

namespace KMobileTools {

namespace Ifaces {

/**
 * This interface provides a collection of wizard pages to be used
 * for the device wizard.
 *
 * @author Matthias Lechner <matthias@lmme.de>
 */
class KMOBILETOOLS_EXPORT WizardProvider {
public:
    /**
     * Returns a list of wizard pages that will be dynamically loaded
     * at runtime by the device wizard
     *
     * @return a list of wizard pages
     */
    virtual QList<QWizardPage*> pageList() const = 0;

    virtual ~WizardProvider();

};

}

}

Q_DECLARE_INTERFACE(KMobileTools::Ifaces::WizardProvider, "org.kde.KMobileTools.Ifaces.WizardProvider/0.1")

#endif
